<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";

@Component({
	components: {
		MediaPicker: () =>
			import("@/components/Seller/Store/Gallery/index.vue"),
	},
})
export default class SettingSellerProductPageDisplayComponent extends Vue {
	mounted() {
		this.setLastMinutes();
	}

	setLastMinutes() {
		clearInterval(this.timerInterVal);
		const lastMinute =
			this.$store.state.sellerStore?.store?.store?.productDisplay
				?.lastMinute || 0;
		if (lastMinute) {
			this.minutes = Math.floor(lastMinute / 60);
			this.second = lastMinute % 60;
		}
		this.timerInterVal = setInterval(() => {
			this.countdownTimer();
		}, 1000);
	}

	get lastMinute() {
		return (
			this.$store.state.sellerStore?.store?.store?.productDisplay
				?.lastMinute || 0
		);
	}

	set lastMinute(val: number) {
		this.$store.commit("sellerStore/setStoreStore", {
			productDisplay: {
				lastMinute: val,
				peopleViewing: this.peopleViewing,
				purchased: this.purchased,
			},
		});
	}

	get peopleViewing() {
		return (
			this.$store.state.sellerStore?.store?.store?.productDisplay
				?.peopleViewing || 0
		);
	}

	set peopleViewing(val: number) {
		this.$store.commit("sellerStore/setStoreStore", {
			productDisplay: {
				peopleViewing: val,
				purchased: this.purchased,
				lastMinute: this.lastMinute,
			},
		});
	}

	get purchased() {
		return (
			this.$store.state.sellerStore?.store?.store?.productDisplay
				?.purchased || 0
		);
	}

	set purchased(val: number) {
		this.$store.commit("sellerStore/setStoreStore", {
			productDisplay: {
				purchased: val,
				peopleViewing: this.peopleViewing,
				lastMinute: this.lastMinute,
			},
		});
	}

	minutes = 0;
	second = 0;
	timerInterVal: any = null;

	countdownTimer() {
		if (this.second === 0 && this.minutes > 0) {
			this.second = 59;
			this.minutes -= 1;
		}
		if (this.minutes === 0 && this.second === 0) {
			clearInterval(this.timerInterVal);
		}
		this.second -= 1;
	}

	@Watch("lastMinute")
	changedLastMinute(val: number) {
		this.setLastMinutes();
	}
}
</script>
